(*
 * SNU 4190.310 Programming Languages (Fall 2006)
 *
 * Errors and handlers
 *)

structure Error =
  struct
    exception Lex_err of string * int

    val linenum = ref 1
    fun incr_ln () = linenum++
    fun decr_ln () = linenum--
    fun get_ln () = !linenum

    fun init () = linenum := 1

    fun handle_exn v =
        case v of
          Lex_err (s, i) =>
          Printf.eprintf ">> lexical error at line %d: %s\n" i s
        | Parsing.Parse_error =>
          Printf.eprintf ">> syntax error at line %d\n" !linenum
        | Arg.Bad s =>
          Printf.eprintf ">> file format error: %s\n" s
        | M.RuntimeError s =>
          Printf.eprintf ">> runtime error: %s\n" s
        | M.TypeError s =>
          Printf.eprintf ">> type error: %s\n" s
        |  _ => raise v
  end
